Index: issm/trunk/src/m/classes/calvingparameterization.m
===================================================================
--- issm/trunk/src/m/classes/calvingparameterization.m	(revision 27035)
+++ issm/trunk/src/m/classes/calvingparameterization.m	(revision 27232)
@@ -6,12 +6,12 @@
 classdef calvingparameterization
 	properties (SetAccess=public) 
-		stress_threshold_groundedice = 0.;
-		stress_threshold_floatingice = 0.;
 		min_thickness = 0.;
 		use_param = 0;
-		scale_theta = 0.;
-		amp_alpha = 0;
-		midp = 0;
-		nonlinearlaw = 0;
+		theta = 0.;
+		alpha = 0;
+		xoffset = 0;
+		yoffset = 0;
+		vel_upperbound = 6000;
+		vel_lowerbound = 0;
 	end
 	methods
@@ -37,24 +37,23 @@
 		end % }}}
 		function self = setdefaultparameters(self) % {{{
-
-			%Default sigma max
-			self.stress_threshold_groundedice = 1e6;
-			self.stress_threshold_floatingice = 150e3;
-
 			%For now we turn this off by setting the threshold to 0
 			self.min_thickness = 0.;
 
 			%parameters for the spatial temporal seperation 
-			%The coefficient follows: \gamma = \frac{\theta}{2}(1-\tanh(\frac{b+p}{\alpha}))+(1-\theta)
-			% 0 - Use bed elevation, 1 - use heigh above floatation
+			%The coefficient follows: gamma= f(x)
+			% 0 - f(x) = y_{o} + \alpha (x+x_{o})
+			% 1 - f(x)=y_{o}-\frac{\theta}{2}\tanh(\alpha(x+x_{o}))
 			self.use_param = 0;
-			% between 0 and 1, larger theta means more reduction for shallower ice
-			self.scale_theta = 0;
-			% alpha in the denominator
-			self.amp_alpha = 0;
-			% mid-point of this step function
-			self.midp = 0;
-			% if use a nonlinear calving law
-			self.nonlinearlaw = 0;
+			% the amplifier
+			self.theta = 0;
+			% the slope alpha 
+			self.alpha = 0;
+			% offset in x-axis 
+			self.xoffset = 0;
+			% offset in y-axis 
+			self.yoffset = 0;
+			% velocity thresholds to reduce calving rate
+			vel_upperbound = 6000; % m/a
+			vel_lowerbound = 0; % m/a
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
@@ -62,36 +61,35 @@
 			if (~strcmp(solution,'TransientSolution') | md.transient.ismovingfront==0), return; end
 
-			md = checkfield(md,'fieldname','calving.stress_threshold_groundedice','>',0,'nan',1,'Inf',1);
-			md = checkfield(md,'fieldname','calving.stress_threshold_floatingice','>',0,'nan',1,'Inf',1);
 			md = checkfield(md,'fieldname','calving.min_thickness','>=',0,'NaN',1,'Inf',1,'numel',1);
 			md = checkfield(md,'fieldname','calving.use_param','values',[-1, 0, 1, 2, 3, 4]);
-			md = checkfield(md,'fieldname','calving.scale_theta','NaN',1,'Inf',1,'numel',1);
-			md = checkfield(md,'fieldname','calving.amp_alpha','<>',0,'NaN',1,'Inf',1,'numel',1);
-			md = checkfield(md,'fieldname','calving.midp','NaN',1,'Inf',1,'numel',1);
-			md = checkfield(md,'fieldname','calving.nonlinearlaw','values',[0, 1]);
+			md = checkfield(md,'fieldname','calving.theta','NaN',1,'Inf',1,'numel',1);
+			md = checkfield(md,'fieldname','calving.alpha','NaN',1,'Inf',1,'numel',1);
+			md = checkfield(md,'fieldname','calving.xoffset','NaN',1,'Inf',1,'numel',1);
+			md = checkfield(md,'fieldname','calving.yoffset','NaN',1,'Inf',1,'numel',1);
+			md = checkfield(md,'fieldname','calving.vel_lowerbound','NaN',1,'Inf',1,'numel',1);
+			md = checkfield(md,'fieldname','calving.vel_upperbound','NaN',1,'Inf',1,'numel',1);
 		end % }}}
 		function disp(self) % {{{
 			disp(sprintf('   Calving test parameters:'));
-			fielddisplay(self,'stress_threshold_groundedice','sigma_max applied to grounded ice only [Pa]');
-			fielddisplay(self,'stress_threshold_floatingice','sigma_max applied to floating ice only [Pa]');
 			fielddisplay(self,'min_thickness','minimum thickness below which no ice is allowed [m]');
-			fielddisplay(self,'use_param','0 - Use bed elevation, 1 - use heigh above floatation, 2 - use ice thickness');
-			fielddisplay(self,'scale_theta','larger than 0, larger theta means more reduction for shallower ice');
-			fielddisplay(self,'amp_alpha','alpha');
-			fielddisplay(self,'midp','mid-point');
-			fielddisplay(self,'nonlinearlaw','use a nonlinear law');
-
+			fielddisplay(self,'use_param','-1 - just use frontal ablation rate, 0 - f(x) = y_{o} + \alpha (x+x_{o}), 1 - f(x)=y_{o}-\frac{\theta}{2}\tanh(\alpha(x+x_{o})), 2 - tanh(thickness), 3 - tanh(normalized vel), 4 - tanh(truncated vel)');
+			fielddisplay(self,'theta','the amplifier');
+			fielddisplay(self,'alpha','the slope');
+			fielddisplay(self,'xoffset','offset in x-axis');
+			fielddisplay(self,'yoffset','offset in y-axis');
+			fielddisplay(self,'vel_lowerbound','lowerbound of ice velocity to reduce the calving rate [m/a]');
+			fielddisplay(self,'vel_upperbound','upperbound of ice velocity to reduce the calving rate [m/a]');
 		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
 			yts=md.constants.yts;
 			WriteData(fid,prefix,'name','md.calving.law','data',9,'format','Integer');
-			WriteData(fid,prefix,'object',self,'fieldname','stress_threshold_groundedice','format','DoubleMat','mattype',1);
-			WriteData(fid,prefix,'object',self,'fieldname','stress_threshold_floatingice','format','DoubleMat','mattype',1);
 			WriteData(fid,prefix,'object',self,'fieldname','min_thickness','format','Double');
 			WriteData(fid,prefix,'object',self,'fieldname','use_param','format','Integer');
-			WriteData(fid,prefix,'object',self,'fieldname','scale_theta','format','Double');
-			WriteData(fid,prefix,'object',self,'fieldname','amp_alpha','format','Double');
-			WriteData(fid,prefix,'object',self,'fieldname','midp','format','Double');
-			WriteData(fid,prefix,'object',self,'fieldname','nonlinearlaw','format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','theta','format','Double');
+			WriteData(fid,prefix,'object',self,'fieldname','alpha','format','Double');
+			WriteData(fid,prefix,'object',self,'fieldname','xoffset','format','Double');
+			WriteData(fid,prefix,'object',self,'fieldname','yoffset','format','Double');
+			WriteData(fid,prefix,'object',self,'fieldname','vel_lowerbound','format','Double','scale', 1./yts);
+			WriteData(fid,prefix,'object',self,'fieldname','vel_upperbound','format','Double','scale', 1./yts);
 		end % }}}
 	end
Index: issm/trunk/src/m/classes/clusters/generic_static.m
===================================================================
--- issm/trunk/src/m/classes/clusters/generic_static.m	(revision 27035)
+++ issm/trunk/src/m/classes/clusters/generic_static.m	(revision 27232)
@@ -39,4 +39,8 @@
 			disp(sprintf('    interactive: %s',cluster.interactive));
 			disp(sprintf('    shell: %s',cluster.shell));
+		end
+		%}}}
+		function numprocs=nprocs(cluster) % {{{
+			numprocs=cluster.np;
 		end
 		%}}}
Index: issm/trunk/src/m/classes/clusters/generic_static.py
===================================================================
--- issm/trunk/src/m/classes/clusters/generic_static.py	(revision 27035)
+++ issm/trunk/src/m/classes/clusters/generic_static.py	(revision 27232)
@@ -52,4 +52,8 @@
         s += "    shell: %s\n" % self.shell
         return s
+    # }}}
+
+    def nprocs(self):  # {{{
+        return self.np
     # }}}
 
Index: issm/trunk/src/m/classes/frictioncoulomb.m
===================================================================
--- issm/trunk/src/m/classes/frictioncoulomb.m	(revision 27035)
+++ issm/trunk/src/m/classes/frictioncoulomb.m	(revision 27232)
@@ -64,5 +64,5 @@
 		end % }}}
 		function disp(self) % {{{
-			disp(sprintf('Basal shear stress parameters: Sigma_b = min( coefficient^2 * Neff ^r * |u_b|^(s-1) * u_b\n, coefficientcoulomb^2 * rho_i * g * (h-h_f)) (effective stress Neff=rho_ice*g*thickness+rho_water*g*bed, r=q/p and s=1/p, floatation thickness h_f=max(0,-rho_sw / rho_i * bed))'));
+			disp(sprintf('Basal shear stress parameters: Sigma_b = min( coefficient^2 * Neff ^r * |u_b|^(s-1) * u_b\n, coefficientcoulomb^2 * Neff) (effective stress Neff=rho_ice*g*thickness+rho_water*g*bed, r=q/p and s=1/p, floatation thickness h_f=max(0,-rho_sw / rho_i * bed))'));
 			fielddisplay(self,'coefficient','power law (Weertman) friction coefficient [SI]');
 			fielddisplay(self,'coefficientcoulomb','Coulomb friction coefficient [SI]');
Index: issm/trunk/src/m/classes/frictioncoulomb.py
===================================================================
--- issm/trunk/src/m/classes/frictioncoulomb.py	(revision 27035)
+++ issm/trunk/src/m/classes/frictioncoulomb.py	(revision 27232)
@@ -28,5 +28,5 @@
     def __repr__(self):  # {{{
         s = 'Basal shear stress parameters: Sigma_b = min(coefficient^2 * Neff ^r * |u_b|^(s - 1) * u_b,\n'
-        s += 'coefficientcoulomb^2 * rho_i * g * (h - h_f)), (effective stress Neff = rho_ice * g * thickness + rho_water * g * bed, r = q / p and s = 1 / p).\n'
+        s += 'coefficientcoulomb^2 * Neff), (effective stress Neff = rho_ice * g * thickness + rho_water * g * bed, r = q / p and s = 1 / p).\n'
         s += '{}\n'.format(fielddisplay(self, "coefficient", "power law (Weertman) friction coefficient [SI]"))
         s += '{}\n'.format(fielddisplay(self, "coefficientcoulomb", "Coulomb friction coefficient [SI]"))
Index: issm/trunk/src/m/classes/hydrologydc.m
===================================================================
--- issm/trunk/src/m/classes/hydrologydc.m	(revision 27035)
+++ issm/trunk/src/m/classes/hydrologydc.m	(revision 27232)
@@ -14,4 +14,5 @@
 		max_iter                 = 0;
 		steps_per_step           = 0;
+		step_adapt               = 0;
 		averaging                = 0;
 		sedimentlimit_flag       = 0;
@@ -66,5 +67,5 @@
 				list=[list,{'EplHead','HydrologydcMaskEplactiveNode','HydrologydcMaskEplactiveElt','EplHeadSlopeX','EplHeadSlopeY','HydrologydcEplThickness'}];
 			end
-			if self.steps_per_step>1,
+			if self.steps_per_step>1 | self.step_adapt,
 				list = [list,'EffectivePressureSubstep','SedimentHeadSubstep'];
 				if self.isefficientlayer,
@@ -90,4 +91,5 @@
 			self.max_iter                 = 100;
 			self.steps_per_step           = 1;
+			self.step_adapt               = 0;
 			self.averaging                = 0;
 			self.sedimentlimit_flag       = 0;
@@ -126,4 +128,5 @@
 			md = checkfield(md,'fieldname','hydrology.max_iter','>',0,'numel',1);
 			md = checkfield(md,'fieldname','hydrology.steps_per_step','>',0,'numel',1);
+			md = checkfield(md,'fieldname','hydrology.step_adapt','numel',1,'values',[0 1]);
 			md = checkfield(md,'fieldname','hydrology.averaging','numel',[1],'values',[0 1 2]);
 			md = checkfield(md,'fieldname','hydrology.sedimentlimit_flag','numel',[1],'values',[0 1 2 3]);
@@ -172,4 +175,5 @@
 			fielddisplay(self,'max_iter','maximum number of nonlinear iteration');
 			fielddisplay(self,'steps_per_step','number of hydrology steps per timestep');
+			fielddisplay(self,'step_adapt', 'adaptative sub stepping  [1: true 0: false] default is 0');
 			fielddisplay(self, 'averaging', 'averaging methods from short to long steps');
 			disp(sprintf('%55s  0: Arithmetic (default)'));
@@ -226,4 +230,5 @@
 			WriteData(fid,prefix,'object',self,'fieldname','max_iter','format','Integer');
 			WriteData(fid,prefix,'object',self,'fieldname','steps_per_step','format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','step_adapt','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','averaging','format','Integer');
 			WriteData(fid,prefix,'object',self,'fieldname','sedimentlimit_flag','format','Integer');
Index: issm/trunk/src/m/classes/hydrologydc.py
===================================================================
--- issm/trunk/src/m/classes/hydrologydc.py	(revision 27035)
+++ issm/trunk/src/m/classes/hydrologydc.py	(revision 27232)
@@ -21,4 +21,5 @@
         self.max_iter = 0
         self.steps_per_step = 0
+        self.step_adapt = 0
         self.averaging = 0
         self.sedimentlimit_flag = 0
@@ -53,5 +54,5 @@
     def __repr__(self):  # {{{
         # TODO:
-        # - Convert all formatting to calls to <string>.format (see any 
+        # - Convert all formatting to calls to <string>.format (see any
         #   already converted <class>.__repr__ method for examples)
         #
@@ -65,4 +66,5 @@
         string = "%s\n%s" % (string, fielddisplay(self, 'max_iter', 'maximum number of nonlinear iteration'))
         string = "%s\n%s" % (string, fielddisplay(self, 'steps_per_step', 'number of hydrology steps per time step'))
+        string = "%s\n%s" % (string, fielddisplay(self, 'step_adapt', 'adaptative sub stepping  [1: true 0: false] default is 0'))
         string = "%s\n%s" % (string, fielddisplay(self, 'averaging', 'averaging methods from short to long steps'))
         string = "%s\n\t\t%s" % (string, '0: Arithmetic (default)')
@@ -134,4 +136,5 @@
         self.max_iter = 100
         self.steps_per_step = 1
+        self.step_adapt = 0
         self.averaging = 0
         self.sedimentlimit_flag = 0
@@ -162,5 +165,5 @@
         if self.isefficientlayer == 1:
             list.extend(['EplHead', 'HydrologydcMaskEplactiveNode', 'HydrologydcMaskEplactiveElt', 'EplHeadSlopeX', 'EplHeadSlopeY', 'HydrologydcEplThickness'])
-        if self.steps_per_step > 1:
+        if self.steps_per_step > 1 or self.step_adapt:
             list.extend(['EffectivePressureSubstep', 'SedimentHeadSubstep'])
             if self.isefficientlayer == 1:
@@ -190,4 +193,5 @@
         md = checkfield(md, 'fieldname', 'hydrology.max_iter', '>', 0., 'numel', [1])
         md = checkfield(md, 'fieldname', 'hydrology.steps_per_step', '>=', 1, 'numel', [1])
+        md = checkfield(md, 'fieldname', 'hydrology.step_adapt', 'numel', [1], 'values', [0, 1])
         md = checkfield(md, 'fieldname', 'hydrology.averaging', 'numel', [1], 'values', [0, 1, 2])
         md = checkfield(md, 'fieldname', 'hydrology.sedimentlimit_flag', 'numel', [1], 'values', [0, 1, 2, 3])
@@ -233,4 +237,5 @@
         WriteData(fid, prefix, 'object', self, 'fieldname', 'max_iter', 'format', 'Integer')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'steps_per_step', 'format', 'Integer')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'step_adapt', 'format', 'Boolean')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'averaging', 'format', 'Integer')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'sedimentlimit_flag', 'format', 'Integer')
Index: issm/trunk/src/m/classes/initialization.m
===================================================================
--- issm/trunk/src/m/classes/initialization.m	(revision 27035)
+++ issm/trunk/src/m/classes/initialization.m	(revision 27232)
@@ -150,6 +150,6 @@
 			yts=md.constants.yts;
 
-			WriteData(fid,prefix,'object',self,'fieldname','vx','format','DoubleMat','mattype',1,'scale',1./yts);
-			WriteData(fid,prefix,'object',self,'fieldname','vy','format','DoubleMat','mattype',1,'scale',1./yts);
+			WriteData(fid,prefix,'object',self,'fieldname','vx','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'fieldname','vy','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
 			WriteData(fid,prefix,'object',self,'fieldname','vz','format','DoubleMat','mattype',1,'scale',1./yts);
 			WriteData(fid,prefix,'object',self,'fieldname','pressure','format','DoubleMat','mattype',1);
Index: issm/trunk/src/m/classes/initialization.py
===================================================================
--- issm/trunk/src/m/classes/initialization.py	(revision 27035)
+++ issm/trunk/src/m/classes/initialization.py	(revision 27232)
@@ -14,5 +14,5 @@
     """
 
-    def __init__(self): #{{{
+    def __init__(self):  #{{{
         self.vx = np.nan
         self.vy = np.nan
@@ -37,5 +37,6 @@
         self.setdefaultparameters()
     #}}}
-    def __repr__(self): #{{{
+
+    def __repr__(self):  #{{{
         s = '   initial field values:\n'
         s += '{}\n'.format(fielddisplay(self, 'vx', 'x component of velocity [m/yr]'))
@@ -53,11 +54,13 @@
         s += '{}\n'.format(fielddisplay(self, 'hydraulic_potential', 'Hydraulic potential (for GlaDS) [Pa]'))
         s += '{}\n'.format(fielddisplay(self, 'channelarea', 'subglaciale water channel area (for GlaDS) [m2]'))
-        s += '{}\n'.format(fielddisplay(self,'sample', 'Realization of a Gaussian random field'))
+        s += '{}\n'.format(fielddisplay(self, 'sample', 'Realization of a Gaussian random field'))
         return s
     #}}}
-    def setdefaultparameters(self): #{{{
+
+    def setdefaultparameters(self):  #{{{
         return
     #}}}
-    def checkconsistency(self, md, solution, analyses): #{{{
+
+    def checkconsistency(self, md, solution, analyses):  #{{{
         if 'StressbalanceAnalysis' in analyses and not solution == 'TransientSolution' and not md.transient.isstressbalance:
             if not np.any(np.logical_or(np.isnan(md.initialization.vx), np.isnan(md.initialization.vy))):
@@ -93,9 +96,13 @@
                 md = checkfield(md, 'fieldname', 'delta Tpmp', 'field', np.absolute(md.initialization.temperature[pos] - (md.materials.meltingpoint - md.materials.beta * md.initialization.pressure[pos])), '<', 1e-11, 'message', 'set temperature to pressure melting point at locations with waterfraction > 0')
         if 'HydrologyShreveAnalysis' in analyses:
-            if hasattr(md.hydrology, 'hydrologyshreve'):
+            if type(md.hydrology).__name__ == 'hydrologyshreve':
                 if (solution == 'TransientSolution' and md.transient.ishydrology) or solution == 'HydrologySolution':
                     md = checkfield(md, 'fieldname', 'initialization.watercolumn', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
+        if 'HydrologyDCAnalysis' in analyses:
+            if type(md.hydrology).__name__ == 'hydrologydc':
+                if (solution == 'TransientSolution' and md.transient.ishydrology) or solution == 'HydrologySolution':
+                    md = checkfield(md, 'fieldname', 'initialization.sediment_head', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
         if 'HydrologyTwsAnalysis' in analyses:
-            if hasattr(md.hydrology, 'hydrologytws'):
+            if type(md.hydrology).__name__ == 'hydrologytws':
                 md = checkfield(md, 'fieldname', 'initialization.watercolumn', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
         if 'SealevelchangeAnalysis' in analyses:
@@ -103,5 +110,5 @@
                 md = checkfield(md, 'fieldname', 'initialization.sealevel', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
         if 'HydrologyGlaDSAnalysis' in analyses:
-            if hasattr(md.hydrology, 'hydrologyglads'):
+            if type(md.hydrology).__name__ == 'hydrologyglads':
                 md = checkfield(md, 'fieldname', 'initialization.watercolumn', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
                 md = checkfield(md, 'fieldname', 'initialization.hydraulic_potential', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
@@ -112,4 +119,5 @@
         return md
     #}}}
+
     def marshall(self, prefix, md, fid): #{{{
         yts = md.constants.yts
@@ -119,5 +127,5 @@
         WriteData(fid, prefix, 'object', self, 'fieldname', 'vz', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1 / yts)
         WriteData(fid, prefix, 'object', self, 'fieldname', 'pressure', 'format', 'DoubleMat', 'mattype', 1)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'sealevel', 'format', 'DoubleMat', 'mattype', 1,'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'sealevel', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts)
         WriteData(fid, prefix, 'object', self, 'fieldname', 'bottompressure', 'format', 'DoubleMat', 'mattype', 1)
         WriteData(fid, prefix, 'object', self, 'fieldname', 'str', 'format', 'DoubleMat', 'mattype', 1)
@@ -143,4 +151,5 @@
             WriteData(fid, prefix, 'data', self.enthalpy, 'format', 'DoubleMat', 'mattype', 1, 'name', 'md.initialization.enthalpy')
     #}}}
+
     def extrude(self, md): #{{{
         self.vx = project3d(md, 'vector', self.vx, 'type', 'node')
Index: issm/trunk/src/m/classes/solidearthsettings.m
===================================================================
--- issm/trunk/src/m/classes/solidearthsettings.m	(revision 27035)
+++ issm/trunk/src/m/classes/solidearthsettings.m	(revision 27232)
@@ -20,7 +20,7 @@
 		compute_bp_grd         = 0; %will GRD patterns for bottom pressures be computed? 
 		degacc                 = 0; %degree increment for resolution of Green tables.
-		timeacc                = 0; %time step accuracy required to compute Green tables
+		timeacc                = 1; %time step accuracy required to compute Green tables
 		horiz                  = 0; %compute horizontal deformation
-		grdmodel               = 0; %grd model (0 by default, 1 for (visco-)elastic, 2 for Ivins)
+		grdmodel               = 1; %grd model (0 by default, 1 for (visco-)elastic, 2 for Ivins)
 		cross_section_shape    = 0; %cross section only used when grd model is Ivins
 	end
@@ -89,27 +89,31 @@
 
 			%no grd model by default:
-			self.grdmodel=0;
+			self.grdmodel=1;
 
 		end % }}}
 		function disp(self) % {{{
 			disp(sprintf('   solidearth settings:'));
-
-			fielddisplay(self,'reltol','sea level change relative convergence criterion (default, NaN: not applied)');
-			fielddisplay(self,'abstol','sea level change absolute convergence criterion(default, NaN: not applied)');
-			fielddisplay(self,'maxiter','maximum number of nonlinear iterations');
-			fielddisplay(self,'grdocean','does this planet have an ocean, if set to 1: global water mass is conserved in GRD module (default: 1)'); 
-			fielddisplay(self,'ocean_area_scaling','correction for model representation of ocean area (default: No correction)'); 
-			fielddisplay(self,'sealevelloading','enables surface loading from sea-level change (default: 1)');
+			disp(sprintf('      core:'));
 			fielddisplay(self,'isgrd','compute GRD patterns (default: 1)');
-			fielddisplay(self,'compute_bp_grd','compute GRD patterns for bottom pressure loads (default: 1)');
-			fielddisplay(self,'runfrequency','how many time steps we skip before we run solidearthsettings solver during transient (default: 1)');
+			fielddisplay(self,'grdmodel','type of deformation model, 0 for no GRD, 1 for spherical GRD model (SESAW model), 2 for half-space planar GRD (visco-elastic model from Ivins)');
+			fielddisplay(self,'runfrequency','How many time steps we let masstransport core accumulate changes before each run of the sealevelchange core (default: 1, i.e run slc every time step)');
+			disp(sprintf('      computational flags:'));
 			fielddisplay(self,'selfattraction','enables surface mass load to perturb the gravity field');
 			fielddisplay(self,'elastic','enables elastic deformation from surface loading');
 			fielddisplay(self,'viscous','enables viscous deformation from surface loading');
 			fielddisplay(self,'rotation','enables polar motion to feedback on the GRD fields');
-			fielddisplay(self,'degacc','accuracy (default: .01 deg) for numerical discretization of the Green''s functions');
+			fielddisplay(self,'compute_bp_grd','compute GRD patterns for bottom pressure loads (default: 1)');
+			fielddisplay(self,'cross_section_shape','1: square-edged (default). 2: elliptical. See iedge in GiaDeflectionCore. Used only for grdmodel=2 only');
+			disp(sprintf('      resolution:'));
+			fielddisplay(self,'degacc','spatial accuracy (default: .01 deg) for numerical discretization of the Green''s functions');
 			fielddisplay(self,'timeacc','time accuracy (default: 1 yr) for numerical discretization of the Green''s functions');
-			fielddisplay(self,'grdmodel','type of deformation model, 0 for no GRD, 1 for spherical GRD model (SESAW model), 2 for half-space planar GRD (visco-elastic model from Ivins)');
-			fielddisplay(self,'cross_section_shape','1: square-edged (default). 2: elliptical. See iedge in GiaDeflectionCore');
+			disp(sprintf('      sea-level equation:'));
+			fielddisplay(self,'grdocean','does this planet have an ocean, if set to 1: global water mass is conserved in GRD module (default: 1)'); 
+			fielddisplay(self,'sealevelloading','enables surface loading from sea-level change (default: 1)');
+			fielddisplay(self,'maxiter','maximum number of nonlinear iterations');
+			fielddisplay(self,'reltol','sea level change relative convergence criterion (default, NaN: not applied)');
+			fielddisplay(self,'abstol','sea level change absolute convergence criterion(default, NaN: not applied)');
+			fielddisplay(self,'ocean_area_scaling','correction for model representation of ocean area (default: No correction)'); 
+
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
@@ -133,4 +137,7 @@
 			if self.viscous==1 & self.elastic==0,
 				error('solidearthsettings checkconsistency error message: need elastic on if viscous flag is set');
+			end
+			if self.rotation==1 & self.elastic==0,
+				error('solidearthsettings checkconsistency error message: need elastic on if rotation flag is set');
 			end
 
@@ -164,4 +171,5 @@
 			WriteData(fid,prefix,'object',self,'fieldname','viscous','name','md.solidearth.settings.viscous','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','rotation','name','md.solidearth.settings.rotation','format','Boolean');
+			WriteData(fid,prefix,'object',self,'fieldname','rotation','name','md.solidearth.settings.satellitegravity','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','grdocean','name','md.solidearth.settings.grdocean','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','ocean_area_scaling','name','md.solidearth.settings.ocean_area_scaling','format','Boolean');
@@ -187,5 +195,5 @@
 			writejsdouble(fid,[modelname '.solidearth.settings.viscous'],self.viscous);
 			writejsdouble(fid,[modelname '.solidearth.settings.rotation'],self.rotation);
-			writejsdouble(fid,[modelname '.solidearth.settings.grdocean'],self.rotation);
+			writejsdouble(fid,[modelname '.solidearth.settings.grdocean'],self.grdocean);
 			writejsdouble(fid,[modelname '.solidearth.settings.ocean_area_scaling'],self.ocean_area_scaling);
 			writejsdouble(fid,[modelname '.solidearth.settings.run_frequency'],self.run_frequency);
Index: issm/trunk/src/m/classes/stochasticforcing.m
===================================================================
--- issm/trunk/src/m/classes/stochasticforcing.m	(revision 27035)
+++ issm/trunk/src/m/classes/stochasticforcing.m	(revision 27232)
@@ -95,14 +95,18 @@
 				end
 				if(contains(field,'WaterPressure'))
-               mdname = structstoch.mdnames(find(strcmp(structstoch.fields,char(field))));
-               if~(isequal(class(md.friction),char(mdname)))
-                  error('stochasticforcing field %s is only implemented for default friction', char(field));
+					mdname = structstoch.mdnames(find(strcmp(structstoch.fields,char(field))));
+					if~(isequal(class(md.friction),char(mdname)))
+                  error('md.friction does not agree with stochasticforcing field %s', char(field));
                end
-               if(md.friction.coupling~=0 && md.friction.coupling~=1 && md.friction.coupling~=2)
-                  error('stochasticforcing field %s is only implemented for cases md.friction.coupling 0 or 1 or 2', char(field));
-               end
-               if(any(md.friction.q==0))
-                  error('stochasticforcing field %s requires non-zero q exponent',char(field));
-               end
+					if(strcmp(class(md.friction),'friction') || strcmp(class(md.friction),'frictionschoof') || strcmp(class(md.friction),'frictioncoulomb'))
+                  if(md.friction.coupling~=0 && md.friction.coupling~=1 && md.friction.coupling~=2)
+                     error('stochasticforcing field %s is only implemented for cases md.friction.coupling 0 or 1 or 2', char(field));
+                  end
+					end
+					if(strcmp(class(md.friction),'friction'))
+                  if(any(md.friction.q==0))
+                     error('stochasticforcing field %s requires non-zero q exponent',char(field));
+                  end
+					end
             end
 				%Checking for specific dimensions
@@ -267,4 +271,6 @@
 		'FloatingMeltRate',...
 		'FrictionWaterPressure',...
+		'FrictionCoulombWaterPressure',...
+		'FrictionSchoofWaterPressure',...
 		'FrontalForcingsRignotAutoregression',...
 		'SMBautoregression',...
@@ -277,4 +283,6 @@
 		'basalforcings',...
 		'friction',...
+		'frictioncoulomb',...
+		'frictionschoof',...
 		'frontalforcingsrignotautoregression',...
 		'SMBautoregression',...
Index: issm/trunk/src/m/classes/stochasticforcing.py
===================================================================
--- issm/trunk/src/m/classes/stochasticforcing.py	(revision 27035)
+++ issm/trunk/src/m/classes/stochasticforcing.py	(revision 27232)
@@ -106,9 +106,11 @@
                 mdname = structstoch[field]
                 if (type(md.friction).__name__ != mdname):
-                    raise TypeError('stochasticforcing field {} is only implemented for default friction'.format(field))
-                if md.friction.coupling not in[0, 1, 2]:
-                    raise TypeError('stochasticforcing field {} is only implemented for cases md.friction.coupling 0 or 1 or 2'.format(field))
-                if (np.any(md.friction.q == 0)):
-                    raise TypeError('stochasticforcing field {} requires non-zero q exponent'.format(field))
+                    raise TypeError('md.friction does not agree with stochasticforcing field {}'.format(field))
+                if (type(md.friction).__name__=='friction' or type(md.friction).__name__=='frictionschoof' or type(md.friction).__name__=='frictioncoulomb'):
+                    if md.friction.coupling not in[0, 1, 2]:
+                        raise TypeError('stochasticforcing field {} is only implemented for cases md.friction.coupling 0 or 1 or 2'.format(field))
+                if (type(md.friction).__name__=='friction'):
+                    if (np.any(md.friction.q == 0)):
+                        raise TypeError('stochasticforcing field {} requires non-zero q exponent'.format(field))
 
             # Checking for specific dimensions
@@ -232,4 +234,6 @@
                      'FloatingMeltRate': 'basalforcings',
                      'FrictionWaterPressure': 'friction',
+                     'FrictionCoulombWaterPressure': 'frictioncoulomb',
+                     'FrictionSchoofWaterPressure': 'frictionschoof',
                      'FrontalForcingsRignotAutoregression': 'frontalforcingsrignotautoregression',
                      'SMBautoregression': 'SMBautoregression',
